#!/usr/bin/perl
# Safe Proofing System -- Design Wizardry, Mike Carambat 2002

#### Unlimited distribution and use. All code herein is public domain for betterment of the VR community.

$imagepath="safeview"; 				# name of folder in cgi-bin containing protected media
$supportdir="support";				# name of suppport folder in $imagepath folder
$progname="nph-safeview.pl";		# name of program (must use nph- in front for non-parsed headers)

$maildir = "/usr/sbin/sendmail";	# path to sendmail program
$sendto="";							# email address to send updated browser request to (not used if left blank)

$width=0;							# Image width in pixels (leave 0 to autodecide width)
$height=0;							# Image height in pixels (leave 0 to autodecide height)

									# IMPORTANT: If protecting Quicktime media, you must 
									# specify width & height above. The system cannot detect 
									# Quicktime size!!!!
									
$defaultwidth="600";				# What Image Width defaults to if undetectable
$defaultheight="398";				# What Image Height defaults to if undetectable

$waitdelay=60; # seconds			# how long before the image pathway expires

$rnd=int(rand(1)*100000);

$waitdelay=$waitdelay/86400;

$command=$ENV{"REQUEST_METHOD"};
$buffer=$ENV{"QUERY_STRING"};
@pairs=split(/&/,$buffer);
$i=0;
foreach $pair (@pairs) {
	($name,$value)=split (/=/,$pair);
	$name =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	chomp($name);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	chomp($value);
	$vars{$name}=$value;
	}

if ($vars{'NEWBROWSER'}) {
	&SendNewBrowser;
	exit(0);
	}

#### Browser detection routines.
#### If a happy browser run StartShow
#### If not a happy browser run NoShow

$browser=$ENV{"HTTP_USER_AGENT"};
$vars{'NEWBROWSER'}=$browser;
($version,@rest)=split(/ /,$browser);
($moz,$vers)=split(/\//,$version);

if (($browser =~ /OPERA/i) || ($browser =~ /ICAB/)) {
	&NoShow;
	}
if ($browser =~ /MSIE/i) {
	&StartShow;
	}
else {
	if (($vers =~ /3./) || ($vers =~ /4.7/) || ($vers =~ /4.01/) || ($vers =~ /4.02/) || ($vers =~ /4.03/) || ($vers =~ /4.04/) || ($vers =~ /4.05/) || ($vers =~ /4.06/) || ($vers =~ /4.07/) || ($vers =~ /4.08/) || ($vers =~ /4.09/) || ($vers =~ /4.6/) || ($browser =~ /NETSCAPE/i)) {
		&StartShow;
		}
	else {
		&NoShow;
		}
	}
exit(0);

####

sub StartShow { # Happy Browser

if ($command eq 'GET') {
	
	if ($vars{'SHOWIMAGE'} ne "") {	
		if ($vars{'SHOWIMAGE'} eq "nothing") {
			$image="$supportdir/nothing.gif";
			}
		elsif ($vars{'SHOWIMAGE'} eq "xmacpaint") {
			$image="$supportdir/uneedqt4.pntg";
			}
		else {
			$image="$supportdir/denied.gif";
			if ((-e "$imagepath/$vars{'SHOWIMAGE'}.chk") && ((-A "$imagepath/$vars{'SHOWIMAGE'}.chk") <= $waitdelay)) {
				open (STUFF,"$imagepath/$vars{'SHOWIMAGE'}.chk");
				$check=<STUFF>;
				close (STUFF);
				chomp ($check);
				if ($check eq $vars{'RND'}) {
					$image=$vars{'SHOWIMAGE'};
					unlink ("$imagepath/$image.chk");
					}
				}
			else {
				unlink ("$imagepath/$vars{'SHOWIMAGE'}.chk");
				}
			}
		&GetMimeType;
		print "$ENV{'SERVER_PROTOCOL'} 200 OK\n";
		print "Server: $ENV{'SERVER_SOFTWARE'}\n";
		
		print "Pragma: no-cache\n";
		print "Expires: Mon, 04 Dec 1999 21:29:02 GMT\n";
		print "Cache-Control: max-age=0, no-cache, must-revalidate\n";
		print "Content-type: $mimetype\n\n";
	
		open (SECRET, "$imagepath/$image");
		binmode(SECRET);
		while(<SECRET>){print $_;}
		close (SECRET);
		exit(0);
		}
		
	if ($vars{'GOPAGE'} ne "") {
		$image=$vars{'GOPAGE'};
		if (-e "$imagepath/$image") {
			$check=1;
			open (STUFF,">$imagepath/$image.chk");
			print STUFF "$rnd";
			close (STUFF);		
			&GetMimeType;
			print "$ENV{'SERVER_PROTOCOL'} 200 OK\n";
			print "Server: $ENV{'SERVER_SOFTWARE'}\n";
			
			print "Pragma: no-cache\n";
			print "Expires: Mon, 04 Dec 1999 21:29:02 GMT\n";
			print "Cache-Control: max-age=0, no-cache, must-revalidate\n";
			print "Content-type: text/html\n\n";
			
#### HTML for Viewing the Media
			print <<BLOCK1;
<html>
<head>
<title>$title</title>
<META HTTP-EQUIV="Pragma" CONTENT = "no-cache">
<META HTTP-EQUIV="Expires" CONTENT="Mon, 04 Dec 1999 21:29:02 GMT">
<META HTTP-EQUIV="CacheControl" CONTENT="no-cache">
<script>
var di=new Image();
function callprog(n) {
	di.src=n;
	}
</script>

</head>
<body bgcolor="#ffffff" $onloadstring>
<center>
<table cellspacing=0 cellpadding=0 border=0 WIDTH=$width>
<tr valign=top>
	<td>
		<script>
		document.writeln ("$showstring");
		</script>
		<noscript>
		<h3>You must have Javascript turned<br>ON to View Media.</h3>
		</noscript>
			</td>
			</tr>
		</table>
	</td>
	</tr>
</table>
</center>
</body>
</html>
BLOCK1

####
			exit(0);
			}
		}
	}
	
print "$ENV{'SERVER_PROTOCOL'} 200 OK\n";
print "Server: $ENV{'SERVER_SOFTWARE'}\n";	
print "Content-type: text/html\n\n";
print "ERROR";
exit(0);
}

sub NoShow { # HTML for Unhappy browser response

print "$ENV{'SERVER_PROTOCOL'} 200 OK\n";
print "Server: $ENV{'SERVER_SOFTWARE'}\n";	
print "Content-type: text/html\n\n";
print <<BLOCK2;
<html>
<head>
<title>Secure Viewing of Media Files</title>
</head>
<body bgcolor="#ffffff" marginwidth=2 marginheight=2 topmargin=2 leftmargin=2 bgcolor="#ffedcc">
<BR><BR>
<center>
<table border=2 width=320 cellpadding=16>
<tr valign=top>
<td bgcolor="#ffffff">
<font face="Helvetica, Arial">
<center><font size=3 color="#ff0000"><b>ILLEGAL BROWSER DETECTED</b></font></center><br>
<br>
<FONT size=2>
<center><b><font color="#0000ff">$message</font></b></center>
We're sorry, but this site uses a protection scheme to protect images viewed on this system from being saved locally. Your browser has been detected to have security concerns which would prevent this system from functioning properly.<br>
<br>
Please return to this site with an approved browser.<br>
<br>
Approved browsers include the following:<br>
<ul>
<li><b>Netscape 3.0 or better</b>
<li><b>Microsoft Internet Explorer 4.0 or better</b>
</ul>
BLOCK2

if ($sendto ne "") {
	print "<center><form action='nph-safeview.pl' method='get'><input type='hidden' name='NEWBROWSER' value='$vars{'NEWBROWSER'}'>
If you feel you are reaching this message in error please click below to submit your browser for approval. We will be emailed your request and will respond immediately to your concern. Browser approval should take less than an hour. Check back soon to see if the versions have been updated.<br><br><input type='submit'></form></center><br>\n";
	}
	
print <<BLOCK3;
<br>
<center><font size=1><i>(last updated 11-14-2001, 2:30PM CST)</i></font></center><br>
<br>
</font>
</font>
</td>
</tr>
</table>
</body>
</html>
BLOCK3
exit(0);
	}
	
#### Mimetype routines
#### Sets up mimetypes based on extension of media file being requested
#### Also, sets up string used to display media

sub GetMimeType {
	if (($image =~ /.mov/i) || ($image =~ /.qt/i)) {
		$mimetype="video/quicktime";
		if (($width==0) or ($height==0)) {
			$width=$defaultwidth;
			$height=$defaultheight;
			}
		$showstring="<OBJECT CLASSID='clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B' CODEBASE='http://www.apple.com/qtactivex/qtplugin.cab' width=$width height=$height><PARAM name='qtsrc' value='$progname?SHOWIMAGE=$image&RND=$rnd'><PARAM name='src' value='$progname?SHOWIMAGE=xmacpaint'><PARAM name='type' value='image/x-macpaint'><PARAM name='pluginspage' value='http://www.apple.com/quicktime/download/'><PARAM name='AUTOPLAY' value='false'><PARAM name='CONTROLLER' value='false'><PARAM name='CACHE' value='false'><PARAM name='KIOSKMODE' value='true'><embed qtsrc='$progname?SHOWIMAGE=$image&RND=$rnd' pluginspage='http://www.apple.com/quicktime/download/' src='$progname?SHOWIMAGE=xmacpaint' type='image/x-macpaint' width=$width height=$height AUTOPLAY=false CONTROLLER=false CACHE=false NOCACHE KIOSKMODE=true></embed></object>";
		$onloadstring="";
		}
		
	if (($image =~ /.jpg/i) || ($image =~ /.jpeg/i)) {
		$mimetype="image/jpeg";
		open(STRM, "<$imagepath/$image");
		binmode(STRM);
		($width, $height) = &jpegsize(\*STRM);
		close(STRM);
		&StandardImage;
		}
		
	if ($image =~ /.gif/i) {
		$mimetype="image/gif";
		open(STRM, "<$imagepath/$image");
		binmode(STRM);
		($width, $height) = &gifsize(\*STRM);
		close(STRM);
		&StandardImage;
		}
		
	if (($image =~ /.png/i) || ($image =~ /.pntg/i)) {
		$mimetype="image/x-macpaint";
		open(STRM, "<$imagepath/$image");
		binmode(STRM);
		($imagewidth, $imageheight) = &pngsize(\*STRM);
		close(STRM);
		&StandardImage;
		}
	}

sub StandardImage {
	if (($width==0) or ($height==0)) {
		$width=$defaultwidth;
		$height=$defaultheight;
		}
	if ($browser =~ /MSIE/i) {
		$showstring="<table cellspacing=0 cellpadding=0 border=0 width=$width><tr><td background='$progname?SHOWIMAGE=$image&RND=$rnd' width=$width height=$height><img src='$progname?SHOWIMAGE=nothing' width=$width height=$height></td></tr></table>";
		$onloadstring="onload=\"callprog('$progname?SHOWIMAGE=$image&RND=$rnd');\"";
		}
	else {
		$showstring="<img name='fixme' src='$progname?SHOWIMAGE=nothing' width=$width height=$height>";
		$onloadstring="onload=\"document['fixme'].src='$progname?SHOWIMAGE=$image&RND=$rnd';\"";
		}
	}
	
####

sub jpegsize {
  my($JPEG) = @_;
  my($done)=0;
  my($c1,$c2,$ch,$s,$length, $dummy)=(0,0,0,0,0,0);
  my($a,$b,$c,$d);

  if(defined($JPEG)             &&
     read($JPEG, $c1, 1)        &&
     read($JPEG, $c2, 1)        &&
     ord($c1) == 0xFF           &&
     ord($c2) == 0xD8           ){
    while (ord($ch) != 0xDA && !$done) {
      # Find next marker (JPEG markers begin with 0xFF)
      # This can hang the program!!
      while (ord($ch) != 0xFF) { return(0,0) unless read($JPEG, $ch, 1); }
      # JPEG markers can be padded with unlimited 0xFF's
      while (ord($ch) == 0xFF) { return(0,0) unless read($JPEG, $ch, 1); }
      # Now, $ch contains the value of the marker.
      if ((ord($ch) >= 0xC0) && (ord($ch) <= 0xC3)) {
        return(0,0) unless read ($JPEG, $dummy, 3);
        return(0,0) unless read($JPEG, $s, 4);
        ($a,$b,$c,$d)=unpack("C"x4,$s);
        return ($c<<8|$d, $a<<8|$b );
      } else {
        # We **MUST** skip variables, since FF's within variable names are
        # NOT valid JPEG markers
        return(0,0) unless read ($JPEG, $s, 2);
        ($c1, $c2) = unpack("C"x2,$s);
        $length = $c1<<8|$c2;
        last if (!defined($length) || $length < 2);
        read($JPEG, $dummy, $length-2);
      }
    }
  }
  return (0,0);
}

sub gifsize {
  my($GIF) = @_;
  my($type,$a,$b,$c,$d,$s)=(0,0,0,0,0,0);

  if(defined( $GIF )            &&
     read($GIF, $type, 6)       &&
     $type =~ /GIF8[7,9]a/      &&
     read($GIF, $s, 4) == 4     ){
    ($a,$b,$c,$d)=unpack("C"x4,$s);
    return ($b<<8|$a,$d<<8|$c);
  }
  return (0,0);
}

sub pngsize {
  my($PNG) = @_;
  my($head) = "";
# my($x,$y);
  my($a, $b, $c, $d, $e, $f, $g, $h)=0;

  if(defined($PNG)                              &&
     read( $PNG, $head, 8 ) == 8                &&
     $head eq "\x89\x50\x4e\x47\x0d\x0a\x1a\x0a" &&
     read($PNG, $head, 4) == 4                  &&
     read($PNG, $head, 4) == 4                  &&
     $head eq "IHDR"                            &&
     read($PNG, $head, 8) == 8                  ){
#   ($x,$y)=unpack("I"x2,$head);   # doesn't work on little-endian machines
#   return ($x,$y);
    ($a,$b,$c,$d,$e,$f,$g,$h)=unpack("C"x8,$head);
    return ($a<<24|$b<<16|$c<<8|$d, $e<<24|$f<<16|$g<<8|$h);
  }
  return (0,0);
}

sub SendNewBrowser {
open(MAIL,"|$maildir -t");
print MAIL "To: $sendto\n";
print MAIL "From: $sendto\n";
print MAIL "Reply-To: $sendto\n";
print MAIL "Subject: RE: BROWSER APPROVAL\n";
print MAIL "\n";
print MAIL "$vars{'NEWBROWSER'}\n";
print MAIL "\n";
close (MAIL);
$message="Message sent...<br><br>";
&NoShow;
}
